

function result = CalErrorTolerance(ptn, w, E)
	% calculate stable pattern
	
	syn = 0;
	
	[ptn_h ptn_w] = size(ptn);
	result = zeros(1,ptn_w);
	for i=1:ptn_w
        count = 0;
        for j=1:100
            tmp_ptn = ptn(:,i);
            
            error = ones(ptn_h,1);

            
            %choice error position
            [tmp idx]= sort(rand(ptn_h,1));
            clear tmp;
            error(idx(1:E)) = error(idx(1:E))*(-1);
            
            err_tmp_ptn = (tmp_ptn.*error);
            err_tmp_ptn_1 = [(tmp_ptn.*error); -1];
            
            
            if(syn==1) % syn mode
                rtn = w*err_tmp_ptn_1;
                rtn(find(rtn~=0)) = sign(rtn(find(rtn~=0)));
                rtn(find(rtn==0)) = sign(tmp_ptn(find(rtn==0)));
                tmp_i = 1;
                while any(rtn ~= tmp_ptn)
                    
                    if(tmp_i>25) % cycle
                        break;
                    end % end of if(tmp_i>100) 
                    
                    rtn = w*err_tmp_ptn_1;
                    rtn(find(rtn~=0)) = sign(rtn(find(rtn~=0)));
                    rtn(find(rtn==0)) = sign(tmp_ptn(find(rtn==0)));
                    
                    tmp_i = tmp_i + 1;
                end %while all(rtn ~= tmp_ptn)
                
                
                if all(rtn == tmp_ptn)
                    count = count+1;
                end %if all(rtn == tmp_ptn)
                
            end % end of if(syn==1) 
            
            
            
            
            if(syn~=1)  % asyn mode
                
                for s = 1:ptn_h
                    out = w(s,:)*err_tmp_ptn_1;
                    if(out~=0) 
                        err_tmp_ptn_1(s) = sign(out);
                    end % end of if(out~=0) 
                end % end of for s = 1:ptn_h
                
                tmp_i = 1;
                while any(err_tmp_ptn_1(1:ptn_h) ~= tmp_ptn)
                    
                    if(tmp_i>25) % cycle
                        break;
                    end
                    
                    for s = 1:ptn_h
                        out = w(s,:)*err_tmp_ptn_1;
                        if(out~=0) 
                            err_tmp_ptn_1(s) = sign(out);
                        end % end of if(out~=0) 
                    end % end of for s = 1:ptn_h
                    tmp_i = tmp_i + 1;
                end % end of while all(rtn == tmp_ptn)
                
                
                if all(err_tmp_ptn_1(1:ptn_h) == tmp_ptn)
                    count = count+1;
                end % end of if all(rtn == tmp_ptn)
                
            end % end of if(syn~=1)
            
            
            
        end % end of for j=1:100
        
        
        result(i) = count;
	end % end of for i=1:ptn_w




end